<template>
  <div class="container mx-auto py-10 h-auto md:w-4/5 w-11/12 px-6">
    <div
      class="w-full h-full rounded border-2 border-gray-300 p-8 relative bg-gray-200"
    >
      <router-link v-if="user && !user.roles.includes('ROLE_STUDIO')" to="/join-us">
        <span 
          class="mb-2 text-white bg-indigo-700 hover:bg-indigo-800 focus:ring-4 focus:ring-indigo-300 font-medium rounded-lg text-sm px-3 py-2 text-center inline-flex items-center  dark:bg-indigo-600 dark:hover:bg-indigo-700 dark:focus:ring-indigo-800"
        >
          Nous rejoindre
        </span>
      </router-link>

      <div
        class="mt-8 grid sm:grid-cols-1 md:grid-cols-2 lg:grid-cols-3 xl:grid-cols-4 gap-8 relative"
      >
        <div v-for="(studio, key) in studios" :key="`${key}`" class="flex">
          <CardStudio :title="studio.name" :description="studio.description"/>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import CardStudio from "./CardStudio"
export default {
  name: "Studio",
  components: {
    CardStudio
  },
  data() {
    return {
      studios: [],
      urlGetStudios: `https://${window.location.hostname}:8443/studios`
    }
  },
  inject: ["createAlert", "user"],
  beforeMount() {
    fetch(this.urlGetStudios, {
      headers: {
        Accept: "application/json",
        "Content-Type": "application/json"
      },
      method: "GET"
    })
      .then((res) => {
        if (res.ok) {
          return res.json()
        } else {
          throw new Error("Something went wrong")
        }
      })
      .then((data) => {
        if (data) {
          this.studios = data
        } else {
          this.createAlert({
            color: "red",
            text: "Une erreur est survenue",
            icon: "times"
          })
        }
      })
      .catch(() => {
        this.createAlert({
          color: "red",
          text: "Une erreur est survenue",
          icon: "times"
        })
      })
  },
}
</script>

<style scoped>
.is-visible {
  display: block;
}
</style>
